<?php 
// Conexión a la base de datos
$servidor = "127.0.0.1";
$usuario = "root";
$contraseña = "";
$baseDeDatos = "registro_db";

// Establecer la conexión a la base de datos
$enlace = mysqli_connect($servidor, $usuario, $contraseña, $baseDeDatos);

if (!$enlace) {
    die("Conexión fallida: " . mysqli_connect_error());
}

session_start(); // Iniciar la sesión para el login

// Verificar si el usuario ya está logueado
if (isset($_SESSION['id'])) {
    header("Location: segunda.html"); // Redirigir a la página principal si ya está logueado
    exit();
}

?>

<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="login.css">
    <title>Inicio</title>
</head>
<body>

<div class="wrapper">
    <div class="card-switch">
        <label class="switch">
            <input type="checkbox" class="toggle">
            <span class="slider"></span>
            <span class="card-side"></span>
            <div class="flip-card__inner">
                <!-- Formulario de inicio de sesión -->
                <div class="flip-card__front">
                    <div class="title">Iniciar sesión</div>
                    <form class="flip-card__form" action="" method="POST">
                        <input class="flip-card__input" name="email_login" placeholder="Email" type="email" required>
                        <input class="flip-card__input" name="contraseña_login" placeholder="Contraseña" type="password" required>
                        <button class="flip-card__btn" type="submit" name="Usuarios">Let`s go!</button>
                    </form>
                </div>

                <!-- Formulario de registro -->
                <div class="flip-card__back">
                    <div class="title">Registrarse</div>
                    <form class="flip-card__form" action="" method="POST">
                        <input class="flip-card__input" name="nombre" placeholder="Nombre" type="text" required>
                        <input class="flip-card__input" name="email" placeholder="Email" type="email" required>
                        <input class="flip-card__input" name="contraseña" placeholder="Contraseña" type="password" required>
                        <button class="flip-card__btn" name="Registro" type="submit">Confirmar</button>
                    </form>
                </div>
            </div>
        </label>
    </div>   
</div>

<?php 

// Procesar formulario de registro
if (isset($_POST['Registro'])) {
    // Obtener y sanitizar los datos del formulario
    $nombre = mysqli_real_escape_string($enlace, $_POST['nombre']);
    $email = mysqli_real_escape_string($enlace, $_POST['email']);
    $contraseña = mysqli_real_escape_string($enlace, $_POST['contraseña']);
    
    // Validar los campos
    if (empty($nombre) || empty($email) || empty($contraseña)) {
        echo "Por favor complete todos los campos.";
    } else {
        // Cifrar la contraseña
        $contraseña_cifrada = password_hash($contraseña, PASSWORD_DEFAULT);

        // Iniciar una transacción
        mysqli_begin_transaction($enlace);

        try {
            // Insertar en la tabla 'registro' (con contraseña cifrada)
            $insertarRegistro = "INSERT INTO registro (nombre, email, contraseña) VALUES ('$nombre', '$email', '$contraseña_cifrada')";
            if (!mysqli_query($enlace, $insertarRegistro)) {
                throw new Exception("Error al insertar en la tabla 'registro'");
            }

            // Insertar en la tabla 'usuarios' (con contraseña cifrada)
            $insertarUsuarios = "INSERT INTO usuarios (nombre, email, contraseña) VALUES ('$nombre', '$email', '$contraseña_cifrada')";
            if (!mysqli_query($enlace, $insertarUsuarios)) {
                throw new Exception("Error al insertar en la tabla 'usuarios'");
            }

            // Si todo es exitoso, confirmar la transacción
            mysqli_commit($enlace);
            echo "Registro exitoso";

        } catch (Exception $e) {
            // Si hay un error, revertir la transacción
            mysqli_roll_back($enlace);
            echo "Error: " . $e->getMessage();
        }
    }
}

// Procesar formulario de inicio de sesión
if (isset($_POST['Usuarios'])) {
    // Obtener los datos de login
    $email = mysqli_real_escape_string($enlace, $_POST['email_login']); // Corregir nombre de la variable
    $contraseña = mysqli_real_escape_string($enlace, $_POST['contraseña_login']); // Corregir nombre de la variable

    // Buscar al usuario en la tabla 'usuarios' por email
    $sql = "SELECT * FROM usuarios WHERE email = '$email'"; // Buscar en la tabla 'usuarios'
    $resultado = mysqli_query($enlace, $sql);

    if (mysqli_num_rows($resultado) > 0) {
        $usuario = mysqli_fetch_assoc($resultado);

        // Verificar la contraseña
        if (password_verify($contraseña, $usuario['contraseña'])) { // Verificar contraseña
            // Si la contraseña es correcta, iniciar sesión y redirigir al inicio
            $_SESSION['id'] = $usuario['id'];  // Guardamos el ID del usuario en la sesión
            $_SESSION['nombre'] = $usuario['nombre']; // Guardamos el nombre del usuario en la sesión
            header("Location: segunda.html"); // Redirigir a la página principal
            exit(); // Detener la ejecución del código posterior
        } else {
            echo "Contraseña incorrecta";
        }
    } else {
        echo "Usuario no encontrado";
    }
}

?>

</body>
</html>
